package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingMarcaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingMarca;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.service.GP_PricingMarcaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingMarcaService")
public class GP_PricingMarcaServiceImpl implements GP_PricingMarcaService {

	@Autowired
	private GP_PricingMarcaDAO pricingMarcaDAO;

	public List<GP_PricingMarca> obtenerTodos() {
		return pricingMarcaDAO.obtenerTodos();
	}

	public GP_PricingMarca obtenerID(Integer id) {
		return pricingMarcaDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingMarca suscribir(GP_PricingMarca entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingMarcaDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingMarca actualizacion(GP_PricingMarca entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingMarcaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingMarca entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingMarcaDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingMarca(GP_Pricing pricing, Marca marca) {
		return pricingMarcaDAO.obtenerPricingMarca(pricing, marca);
	}

	@Override
	public List<GP_PricingMarca> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingMarcaDAO.obtenerTodoPorPricing(pricing);
	}
}
